#!/usr/bin/env python


def find_words(num_letters, mask):
    word_list = []
    with open("/usr/share/dict/words") as words:
        for word in words:
            word = word.strip()
            if len(word) == num_letters:
                is_word = True
                for position, letter in enumerate(mask):
                    if letter == '_':
                        continue
                    if letter != word[position]:
                        is_word = False

                if is_word:
                    word_list.append(word)
    return word_list


def main():
    """Crossword word solver. Enter number of letters and a mask using underscores to denote unknown letter.
    example: 5 _q___
    """

    correct_input = False
    while not(correct_input):
        print("Number of letters")
        letters = input()
        num_letters = int(letters)
        print("mask")
        mask = input()
        if len(mask) != num_letters:
            print("Length of mask doesn't equal number of letters. Try again.")
        else:
            correct_input = True
    words = find_words(num_letters, mask)
    print("\n")
    print("Here's what I found:")
    print("--------------------")
    for word in words:
        print(word)


if __name__ == "__main__":
    main()
